Index: tests/regression/Atoms/Translation/testsuite-atoms-translation.at
===================================================================
--- tests/regression/Atoms/Translation/testsuite-atoms-translation.at	(revision a84e8d0ab1d22d7db69a2ac4a869d411549a066b)
+++ tests/regression/Atoms/Translation/testsuite-atoms-translation.at	(revision 066442d357f0a016de2922eff675320398a5ba17)
@@ -24,5 +24,5 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Atoms/Translation/pre/test.xyz $file], 0)
 AT_CHECK([chmod u+w $file], 0)
-AT_CHECK([../../molecuilder -i $file --select-all-atoms -t "1,0,0"], 0, [stdout], [stderr])
+AT_CHECK([../../molecuilder -i $file --select-all-atoms --translate-atoms --position "1,0,0"], 0, [stdout], [stderr])
 AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Atoms/Translation/post/test-shifted.xyz], 0, [ignore], [ignore])
 
@@ -36,5 +36,5 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Atoms/Translation/pre/test.xyz $file], 0)
 AT_CHECK([chmod u+w $file], 0)
-AT_CHECK([../../molecuilder -i $file --select-all-atoms -t "1,0,0" --undo], 0, [stdout], [stderr])
+AT_CHECK([../../molecuilder -i $file --select-all-atoms --translate-atoms --position "1,0,0" --undo], 0, [stdout], [stderr])
 AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Atoms/Translation/pre/test.xyz], 0, [ignore], [ignore])
 
@@ -48,5 +48,5 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Atoms/Translation/pre/test.xyz $file], 0)
 AT_CHECK([chmod u+w $file], 0)
-AT_CHECK([../../molecuilder -i $file --select-all-atoms -t "1,0,0" --undo --redo], 0, [stdout], [stderr])
+AT_CHECK([../../molecuilder -i $file --select-all-atoms --translate-atoms --position "1,0,0" --undo --redo], 0, [stdout], [stderr])
 AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Atoms/Translation/post/test-shifted.xyz], 0, [ignore], [ignore])
 
Index: tests/regression/Molecules/Translation-Periodic/testsuite-molecules-translation-periodic.at
===================================================================
--- tests/regression/Molecules/Translation-Periodic/testsuite-molecules-translation-periodic.at	(revision a84e8d0ab1d22d7db69a2ac4a869d411549a066b)
+++ tests/regression/Molecules/Translation-Periodic/testsuite-molecules-translation-periodic.at	(revision 066442d357f0a016de2922eff675320398a5ba17)
@@ -1,5 +1,5 @@
 #
 #    MoleCuilder - creates and alters molecular systems
-#    Copyright (C) 2008-2012 University of Bonn
+#    Copyright (C) 2014 Frederik Heber
 #
 #    This program is free software: you can redistribute it and/or modify
@@ -19,10 +19,10 @@
 
 AT_SETUP([Molecules - Translation with periodic boundaries])
-AT_KEYWORDS([molecules translate-atoms])
+AT_KEYWORDS([molecules translate-molecules])
 
 file=test.conf
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Molecules/Translation-Periodic/pre/test.conf $file], 0)
 AT_CHECK([chmod u+w $file], 0)
-AT_CHECK([../../molecuilder -i $file  --select-molecule-by-id 0 --select-molecules-atoms -t "-8., -8., -8." --periodic 1], 0, [stdout], [stderr])
+AT_CHECK([../../molecuilder -i $file  --select-molecule-by-id 0 --translate-molecules --position "-8., -8., -8." --periodic 1], 0, [stdout], [stderr])
 AT_CHECK([diff $file ${abs_top_srcdir}/tests/regression/Molecules/Translation-Periodic/post/test.conf], 0, [ignore], [ignore])
 
@@ -31,10 +31,10 @@
 
 AT_SETUP([Molecules - Translation with periodic boundaries with Undo])
-AT_KEYWORDS([molecules translate-atoms undo])
+AT_KEYWORDS([molecules translate-molecules undo])
 
 file=test.conf
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Molecules/Translation-Periodic/pre/test.conf $file], 0)
 AT_CHECK([chmod u+w $file], 0)
-AT_CHECK([../../molecuilder -i $file  --select-molecule-by-id 0 --select-molecules-atoms -t "-8., -8., -8." --periodic 1 --undo], 0, [stdout], [stderr])
+AT_CHECK([../../molecuilder -i $file  --select-molecule-by-id 0 --translate-molecules --position "-8., -8., -8." --periodic 1 --undo], 0, [stdout], [stderr])
 AT_CHECK([diff $file ${abs_top_srcdir}/tests/regression/Molecules/Translation-Periodic/post/test-undo.conf], 0, [ignore], [ignore])
 
@@ -43,10 +43,10 @@
 
 AT_SETUP([Molecules - Translation with periodic boundaries with Redo])
-AT_KEYWORDS([molecules translate-atoms redo])
+AT_KEYWORDS([molecules translate-molecules redo])
 
 file=test.conf
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Molecules/Translation-Periodic/pre/test.conf $file], 0)
 AT_CHECK([chmod u+w $file], 0)
-AT_CHECK([../../molecuilder -i $file  --select-molecule-by-id 0 --select-molecules-atoms -t "-8., -8., -8." --periodic 1 --undo --redo], 0, [stdout], [stderr])
+AT_CHECK([../../molecuilder -i $file  --select-molecule-by-id 0 --translate-molecules --position "-8., -8., -8." --periodic 1 --undo --redo], 0, [stdout], [stderr])
 AT_CHECK([diff $file ${abs_top_srcdir}/tests/regression/Molecules/Translation-Periodic/post/test.conf], 0, [ignore], [ignore])
 
Index: tests/regression/Molecules/Translation/testsuite-molecules-translation.at
===================================================================
--- tests/regression/Molecules/Translation/testsuite-molecules-translation.at	(revision a84e8d0ab1d22d7db69a2ac4a869d411549a066b)
+++ tests/regression/Molecules/Translation/testsuite-molecules-translation.at	(revision 066442d357f0a016de2922eff675320398a5ba17)
@@ -1,5 +1,5 @@
 #
 #    MoleCuilder - creates and alters molecular systems
-#    Copyright (C) 2008-2012 University of Bonn
+#    Copyright (C) 2014 Frederik Heber
 #
 #    This program is free software: you can redistribute it and/or modify
@@ -19,10 +19,10 @@
 
 AT_SETUP([Molecules - Translation])
-AT_KEYWORDS([molecules translate-atoms])
+AT_KEYWORDS([molecules translate-molecules])
 
 file=test.conf
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Molecules/Translation/pre/test.conf $file], 0)
 AT_CHECK([chmod u+w $file], 0)
-AT_CHECK([../../molecuilder -i $file --select-molecule-by-id 0 --select-molecules-atoms -t "1., 1., 1." --periodic 0], 0, [stdout], [stderr])
+AT_CHECK([../../molecuilder -i $file --select-molecule-by-id 0 --translate-molecules --position "1., 1., 1." --periodic 0], 0, [stdout], [stderr])
 AT_CHECK([diff $file ${abs_top_srcdir}/tests/regression/Molecules/Translation/post/test.conf], 0, [ignore], [ignore])
 
@@ -30,5 +30,5 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Molecules/Translation/pre/test2.conf $file], 0)
 AT_CHECK([chmod u+w $file], 0)
-AT_CHECK([../../molecuilder -i $file --select-molecule-by-id 0 --select-molecules-atoms -t "-1., -1., -1." --periodic 0], 0, [stdout], [stderr])
+AT_CHECK([../../molecuilder -i $file --select-molecule-by-id 0 --translate-molecules --position "-1., -1., -1." --periodic 0], 0, [stdout], [stderr])
 AT_CHECK([diff $file ${abs_top_srcdir}/tests/regression/Molecules/Translation/post/test2.conf], 0, [ignore], [ignore])
 
@@ -37,10 +37,10 @@
 
 AT_SETUP([Molecules - Translation with Undo])
-AT_KEYWORDS([molecules translate-atoms undo])
+AT_KEYWORDS([molecules translate-molecules undo])
 
 file=test.conf
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Molecules/Translation/pre/test.conf $file], 0)
 AT_CHECK([chmod u+w $file], 0)
-AT_CHECK([../../molecuilder -i $file --select-molecule-by-id 0 --select-molecules-atoms -t "1., 1., 1." --periodic 0 --undo], 0, [stdout], [stderr])
+AT_CHECK([../../molecuilder -i $file --select-molecule-by-id 0 --translate-molecules --position "1., 1., 1." --periodic 0 --undo], 0, [stdout], [stderr])
 AT_CHECK([diff $file ${abs_top_srcdir}/tests/regression/Molecules/Translation/post/test-undo.conf], 0, [ignore], [ignore])
 
@@ -48,5 +48,5 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Molecules/Translation/pre/test2.conf $file], 0)
 AT_CHECK([chmod u+w $file], 0)
-AT_CHECK([../../molecuilder -i $file --select-molecule-by-id 0 --select-molecules-atoms -t "-1., -1., -1." --periodic 0 --undo], 0, [stdout], [stderr])
+AT_CHECK([../../molecuilder -i $file --select-molecule-by-id 0 --translate-molecules --position "-1., -1., -1." --periodic 0 --undo], 0, [stdout], [stderr])
 AT_CHECK([diff $file ${abs_top_srcdir}/tests/regression/Molecules/Translation/post/test2-undo.conf], 0, [ignore], [ignore])
 
@@ -55,10 +55,10 @@
 
 AT_SETUP([Molecules - Translation with Redo])
-AT_KEYWORDS([molecules translate-atoms redo])
+AT_KEYWORDS([molecules translate-molecules redo])
 
 file=test.conf
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Molecules/Translation/pre/test.conf $file], 0)
 AT_CHECK([chmod u+w $file], 0)
-AT_CHECK([../../molecuilder -i $file --select-molecule-by-id 0 --select-molecules-atoms -t "1., 1., 1." --periodic 0 --undo --redo], 0, [stdout], [stderr])
+AT_CHECK([../../molecuilder -i $file --select-molecule-by-id 0 --translate-molecules --position "1., 1., 1." --periodic 0 --undo --redo], 0, [stdout], [stderr])
 AT_CHECK([diff $file ${abs_top_srcdir}/tests/regression/Molecules/Translation/post/test.conf], 0, [ignore], [ignore])
 
@@ -66,5 +66,5 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Molecules/Translation/pre/test2.conf $file], 0)
 AT_CHECK([chmod u+w $file], 0)
-AT_CHECK([../../molecuilder -i $file --select-molecule-by-id 0 --select-molecules-atoms -t "-1., -1., -1." --periodic 0 --undo --redo], 0, [stdout], [stderr])
+AT_CHECK([../../molecuilder -i $file --select-molecule-by-id 0 --translate-molecules --position "-1., -1., -1." --periodic 0 --undo --redo], 0, [stdout], [stderr])
 AT_CHECK([diff $file ${abs_top_srcdir}/tests/regression/Molecules/Translation/post/test2.conf], 0, [ignore], [ignore])
 
Index: tests/regression/Options/InvalidCommands/testsuite-options-invalid-commands.at
===================================================================
--- tests/regression/Options/InvalidCommands/testsuite-options-invalid-commands.at	(revision a84e8d0ab1d22d7db69a2ac4a869d411549a066b)
+++ tests/regression/Options/InvalidCommands/testsuite-options-invalid-commands.at	(revision 066442d357f0a016de2922eff675320398a5ba17)
@@ -24,5 +24,4 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Options/InvalidCommands/pre/test.conf $file], 0)
 AT_CHECK([chmod u+w $file], 0)
-AT_CHECK([../../molecuilder -i $file  -t], 134, [ignore], [stderr])
 AT_CHECK([../../molecuilder -i $file  -s -b -E -c -b -a], 134, [ignore], [stderr])
 AT_CHECK([../../molecuilder -i $file  -b -E -c -b -a], 134, [ignore], [stderr])
Index: tests/regression/Parser/Mpqc/testsuite-parser-mpqc-load-multiply.at
===================================================================
--- tests/regression/Parser/Mpqc/testsuite-parser-mpqc-load-multiply.at	(revision a84e8d0ab1d22d7db69a2ac4a869d411549a066b)
+++ tests/regression/Parser/Mpqc/testsuite-parser-mpqc-load-multiply.at	(revision 066442d357f0a016de2922eff675320398a5ba17)
@@ -24,5 +24,5 @@
 destfile=doublewater.in
 AT_CHECK([../../molecuilder -i $destfile -o mpqc -l ${abs_top_srcdir}/tests/regression/Parser/Mpqc/pre/$srcfile], 0, [ignore], [ignore])
-AT_CHECK([../../molecuilder -i $destfile -l ${abs_top_srcdir}/tests/regression/Parser/Mpqc/pre/$srcfile --select-molecule-by-order -1 --select-molecules-atoms --translate-atoms "2,0,0"], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder -i $destfile -l ${abs_top_srcdir}/tests/regression/Parser/Mpqc/pre/$srcfile --select-molecule-by-order -1 --select-molecules-atoms --translate-atoms --position "2,0,0"], 0, [ignore], [ignore])
 AT_CHECK([diff -I '%.*' $destfile ${abs_top_srcdir}/tests/regression/Parser/Mpqc/post/$destfile], 0, [ignore], [ignore])
 
Index: tests/regression/Parser/Pcp/testsuite-parser-pcp-load-multiply.at
===================================================================
--- tests/regression/Parser/Pcp/testsuite-parser-pcp-load-multiply.at	(revision a84e8d0ab1d22d7db69a2ac4a869d411549a066b)
+++ tests/regression/Parser/Pcp/testsuite-parser-pcp-load-multiply.at	(revision 066442d357f0a016de2922eff675320398a5ba17)
@@ -24,5 +24,5 @@
 destfile=doublewater.conf
 AT_CHECK([../../molecuilder -i $destfile -o pcp -l ${abs_top_srcdir}/tests/regression/Parser/Pcp/pre/$srcfile], 0, [ignore], [ignore])
-AT_CHECK([../../molecuilder -i $destfile -l ${abs_top_srcdir}/tests/regression/Parser/Pcp/pre/$srcfile --select-molecule-by-order -1 --select-molecules-atoms --translate-atoms "2,0,0"], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder -i $destfile -l ${abs_top_srcdir}/tests/regression/Parser/Pcp/pre/$srcfile --select-molecule-by-order -1 --select-molecules-atoms --translate-atoms --position "2,0,0"], 0, [ignore], [ignore])
 AT_CHECK([diff $destfile ${abs_top_srcdir}/tests/regression/Parser/Pcp/post/$destfile], 0, [ignore], [ignore])
 
Index: tests/regression/Parser/Pdb/testsuite-parser-pdb-load-multiply.at
===================================================================
--- tests/regression/Parser/Pdb/testsuite-parser-pdb-load-multiply.at	(revision a84e8d0ab1d22d7db69a2ac4a869d411549a066b)
+++ tests/regression/Parser/Pdb/testsuite-parser-pdb-load-multiply.at	(revision 066442d357f0a016de2922eff675320398a5ba17)
@@ -24,5 +24,5 @@
 destfile=doublewater.pdb
 AT_CHECK([../../molecuilder -i $destfile -o pdb -l ${abs_top_srcdir}/tests/regression/Parser/Pdb/pre/$srcfile], 0, [ignore], [ignore])
-AT_CHECK([../../molecuilder -i $destfile -l ${abs_top_srcdir}/tests/regression/Parser/Pdb/pre/$srcfile --select-molecule-by-order -1 --select-molecules-atoms --translate-atoms "2,0,0"], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder -i $destfile -l ${abs_top_srcdir}/tests/regression/Parser/Pdb/pre/$srcfile --select-molecule-by-order -1 --select-molecules-atoms --translate-atoms --position "2,0,0"], 0, [ignore], [ignore])
 AT_CHECK([diff -I 'REMARK.*' $destfile ${abs_top_srcdir}/tests/regression/Parser/Pdb/post/$destfile], 0, [ignore], [ignore])
 
Index: tests/regression/Parser/Psi3/testsuite-parser-psi3-load-multiply.at
===================================================================
--- tests/regression/Parser/Psi3/testsuite-parser-psi3-load-multiply.at	(revision a84e8d0ab1d22d7db69a2ac4a869d411549a066b)
+++ tests/regression/Parser/Psi3/testsuite-parser-psi3-load-multiply.at	(revision 066442d357f0a016de2922eff675320398a5ba17)
@@ -24,5 +24,5 @@
 destfile=doublewater.psi
 AT_CHECK([../../molecuilder -i $destfile -o psi3 -l ${abs_top_srcdir}/tests/regression/Parser/Psi3/pre/$srcfile], 0, [ignore], [ignore])
-AT_CHECK([../../molecuilder -i $destfile -l ${abs_top_srcdir}/tests/regression/Parser/Psi3/pre/$srcfile --select-molecule-by-order -1 --select-molecules-atoms --translate-atoms "2,0,0"], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder -i $destfile -l ${abs_top_srcdir}/tests/regression/Parser/Psi3/pre/$srcfile --select-molecule-by-order -1 --select-molecules-atoms --translate-atoms --position "2,0,0"], 0, [ignore], [ignore])
 AT_CHECK([diff -w -I '%.*' $destfile ${abs_top_srcdir}/tests/regression/Parser/Psi3/post/$destfile], 0, [ignore], [ignore])
 
Index: tests/regression/Parser/Tremolo/testsuite-parser-tremolo-load-multiply.at
===================================================================
--- tests/regression/Parser/Tremolo/testsuite-parser-tremolo-load-multiply.at	(revision a84e8d0ab1d22d7db69a2ac4a869d411549a066b)
+++ tests/regression/Parser/Tremolo/testsuite-parser-tremolo-load-multiply.at	(revision 066442d357f0a016de2922eff675320398a5ba17)
@@ -25,5 +25,5 @@
 destfile=doublewater.data
 AT_CHECK([../../molecuilder -i $destfile -o tremolo -l ${abs_top_srcdir}/tests/regression/Parser/Tremolo/pre/$srcfile], 0, [ignore], [ignore])
-AT_CHECK([../../molecuilder -i $destfile -l ${abs_top_srcdir}/tests/regression/Parser/Tremolo/pre/$srcfile --select-molecule-by-order -1 --select-molecules-atoms --translate-atoms "2,0,0"], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder -i $destfile -l ${abs_top_srcdir}/tests/regression/Parser/Tremolo/pre/$srcfile --select-molecule-by-order -1 --select-molecules-atoms --translate-atoms --position "2,0,0"], 0, [ignore], [ignore])
 AT_CHECK([diff -w -I '#.*' $destfile ${abs_top_srcdir}/tests/regression/Parser/Tremolo/post/$destfile], 0, [ignore], [ignore])
 
Index: tests/regression/Parser/Xyz/testsuite-parser-xyz-load-multiply.at
===================================================================
--- tests/regression/Parser/Xyz/testsuite-parser-xyz-load-multiply.at	(revision a84e8d0ab1d22d7db69a2ac4a869d411549a066b)
+++ tests/regression/Parser/Xyz/testsuite-parser-xyz-load-multiply.at	(revision 066442d357f0a016de2922eff675320398a5ba17)
@@ -24,5 +24,5 @@
 destfile=doublewater.xyz
 AT_CHECK([../../molecuilder -i $destfile -o xyz -l ${abs_top_srcdir}/tests/regression/Parser/Xyz/pre/$srcfile], 0, [ignore], [ignore])
-AT_CHECK([../../molecuilder -i $destfile -l ${abs_top_srcdir}/tests/regression/Parser/Xyz/pre/$srcfile --select-molecule-by-order -1 --select-molecules-atoms --translate-atoms "2,0,0"], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder -i $destfile -l ${abs_top_srcdir}/tests/regression/Parser/Xyz/pre/$srcfile --select-molecule-by-order -1 --select-molecules-atoms --translate-atoms --position "2,0,0"], 0, [ignore], [ignore])
 AT_CHECK([diff -I '.*Created by molecuilder.*' $destfile ${abs_top_srcdir}/tests/regression/Parser/Xyz/post/$destfile], 0, [ignore], [ignore])
 