Index: molecuilder/src/analyzer.cpp
===================================================================
--- molecuilder/src/analyzer.cpp	(revision 0cc323f357dbbf84f5d08197b4018d05e37948ac)
+++ molecuilder/src/analyzer.cpp	(revision 75793b2621c70ff48fb891bb081f6785de9cb41d)
@@ -312,5 +312,5 @@
   // min/mean/max comparison for total force
   if(!OpenOutputFile(output, argv[3], "DeltaMinMeanMaxTotalForce-Order.pyx")) return 1;
-  CreatePlotHeader(output, "DeltaMinMeanMaxTotalForce-Order", 1, "bottom left", "y", "",  1, 1, "bond order k", "absolute error in total forces [Ht/a.u.]");
+  CreatePlotHeader(output, "DeltaMinMeanMaxTotalForce-Order", 1, "bottom left", "y", NULL,  1, 1, "bond order k", "absolute error in total forces [Ht/a.u.]");
   output << "plot " << Orderxrange.str().c_str() << " [1e-8:1e+0] \\" << endl;  
   output << "'DeltaMinForces-Order.dat' title 'minimum' using 1:(sqrt($" << 8 << "*$" << 8 << "+$" << 8+1 << "*$" << 8+1 << "+$" << 8+2 << "*$" << 8+2 << ")) with linespoints, \\" << endl;
@@ -331,5 +331,5 @@
   // min/mean/max comparison for total force
   if(!OpenOutputFile(output, argv[3],"MinMeanMaxTotalForce-Order.pyx")) return 1;
-  CreatePlotHeader(output, "MinMeanMaxTotalForce-Order", 1, "bottom left", "y", "", 1, 1, "bond order k", "absolute total force [Ht/a.u.]");
+  CreatePlotHeader(output, "MinMeanMaxTotalForce-Order", 1, "bottom left", "y", NULL, 1, 1, "bond order k", "absolute total force [Ht/a.u.]");
   output << "plot "<< Orderxrange.str().c_str() << " [1e-8:1e+0] \\" << endl;  
   output << "'MinForces-Order.dat' title 'minimum' using 1:(sqrt($" << 8 << "*$" << 8 << "+$" << 8+1 << "*$" << 8+1 << "+$" << 8+2 << "*$" << 8+2 << ")) with linespoints, \\" << endl;
Index: molecuilder/src/bond.cpp
===================================================================
--- molecuilder/src/bond.cpp	(revision 0cc323f357dbbf84f5d08197b4018d05e37948ac)
+++ molecuilder/src/bond.cpp	(revision 75793b2621c70ff48fb891bb081f6785de9cb41d)
@@ -140,7 +140,7 @@
  * \return true if it is either bond::leftatom or bond::rightatom, false otherwise
  */
-bool bond::Contains(const int nr)
+bool bond::Contains(const int number)
 {
-  return ((leftatom->nr == nr) || (rightatom->nr == nr));
+  return ((leftatom->nr == number) || (rightatom->nr == number));
 };
 
Index: molecuilder/src/datacreator.cpp
===================================================================
--- molecuilder/src/datacreator.cpp	(revision 0cc323f357dbbf84f5d08197b4018d05e37948ac)
+++ molecuilder/src/datacreator.cpp	(revision 75793b2621c70ff48fb891bb081f6785de9cb41d)
@@ -319,7 +319,7 @@
   output << "set mxtics "<< mxtics << endl;
   output << "set xtics "<< xtics << endl;
-  if (logscale != "")
+  if (logscale != NULL)
     output << "set logscale " << logscale << endl;
-  if (extraline != "")
+  if (extraline != NULL)
     output << extraline << endl;
   output << "set xlabel '" << xlabel << "'" << endl;
Index: molecuilder/src/element.cpp
===================================================================
--- molecuilder/src/element.cpp	(revision 0cc323f357dbbf84f5d08197b4018d05e37948ac)
+++ molecuilder/src/element.cpp	(revision 75793b2621c70ff48fb891bb081f6785de9cb41d)
@@ -41,8 +41,8 @@
  * \param NoOfAtoms total number of atom of this element type
  */
-bool element::Checkout(ofstream *out, const int No, const int NoOfAtoms) const
+bool element::Checkout(ofstream *out, const int Number, const int NoOfAtoms) const
 { 
   if (out != NULL) {
-    *out << "Ion_Type" << No << "\t" << NoOfAtoms << "\t" << Z << "\t1.0\t3\t3\t" << fixed << setprecision(11) << showpoint << mass << "\t" << name << "\t" << symbol <<endl;
+    *out << "Ion_Type" << Number << "\t" << NoOfAtoms << "\t" << Z << "\t1.0\t3\t3\t" << fixed << setprecision(11) << showpoint << mass << "\t" << name << "\t" << symbol <<endl;
     return true;
   } else
Index: molecuilder/src/parser.cpp
===================================================================
--- molecuilder/src/parser.cpp	(revision 0cc323f357dbbf84f5d08197b4018d05e37948ac)
+++ molecuilder/src/parser.cpp	(revision 75793b2621c70ff48fb891bb081f6785de9cb41d)
@@ -101,5 +101,5 @@
   ifstream input;
   char *FragmentNumber = NULL;
-  stringstream line;
+  stringstream file;
   
   Header = (char *) Malloc(sizeof(char)*1023, "MatrixContainer::ParseMatrix: *EnergyHeader");
@@ -107,8 +107,8 @@
   // count the number of matrices
   MatrixCounter = -1; // we count one too much
-  line << name << FRAGMENTPREFIX << KEYSETFILE;
-  input.open(line.str().c_str(), ios::in);
+  file << name << FRAGMENTPREFIX << KEYSETFILE;
+  input.open(file.str().c_str(), ios::in);
   if (input == NULL) {
-    cout << endl << "Unable to open " << line.str() << ", is the directory correct?" << endl;
+    cout << endl << "Unable to open " << file.str() << ", is the directory correct?" << endl;
     return false;
   }
@@ -182,10 +182,10 @@
       Matrix[i][j] = (double *) Malloc(sizeof(double)*ColumnCounter, "MatrixContainer::ParseMatrix: *Matrix[][]");
       input.getline(filename, 1023);
-      stringstream line(filename);
+      stringstream lines(filename);
       //cout << "Matrix at level " << j << ":";// << filename << endl;
       for(int k=skipcolumns;k--;)
-        line >> filename;
+        lines >> filename;
       for(int k=0;(k<ColumnCounter) && (!line.eof());k++) {
-        line >> Matrix[i][j][k];
+        lines >> Matrix[i][j][k];
         //cout << " " << setprecision(2) << Matrix[i][j][k];;
       }
@@ -522,5 +522,5 @@
   ifstream input;
   char *FragmentNumber = NULL;
-  stringstream line;
+  stringstream file;
   char filename[1023];
   
@@ -530,8 +530,8 @@
   for(int i=FragmentCounter;i--;)
     KeySets[i] = NULL;
-  line << name << FRAGMENTPREFIX << KEYSETFILE;
-  input.open(line.str().c_str(), ios::in);
+  file << name << FRAGMENTPREFIX << KEYSETFILE;
+  input.open(file.str().c_str(), ios::in);
   if (input == NULL) {
-    cout << endl << "Unable to open " << line.str() << ", is the directory correct?" << endl;
+    cout << endl << "Unable to open " << file.str() << ", is the directory correct?" << endl;
     return false;
   }